<template>
  <div
    class="flex align-items-center justify-content-center pt-8"
  >
    <div class="surface-card p-4 shadow-2 border-round w-full lg:w-6 ml-4 mr-4">
      <div class="text-2xl">Create your account</div>

      <form @submit.prevent="register">
        <div class="surface-section pt-4 pb-4">
          <div class="grid formgrid p-fluid">
            <div v-if="error.message" class="field mb-4-col-12 w-full">
              <Message severity="error">{{ error.message }}</Message>
            </div>
            <div class="field mb-4 col-12">
              <label for="email" class="font-medium">Email</label>
              <InputText v-model="registration.email" id="email" type="email" />
            </div>
            <div class="field mb-4 col-12">
              <label for="password" class="font-medium">Password</label>
              <InputText
                v-model="registration.password"
                id="password"
                type="password"
              />
            </div>
            <div class="field mb-4 col-12">
              <label for="confirmPassword" class="font-medium">
                Confirm Password
              </label>
              <InputText
                v-model="registration.confirmPassword"
                id="confirmPassword"
                type="password"
              />
            </div>
            <div class="col-12">
              <Button
                @click="register"
                label="Register"
                type="submit"
                class="w-full mt-3"
              ></Button>
            </div>
          </div>
        </div>
      </form>
      <div class="flex justify-content-center align-content-center">
        Already registered? Click
        <router-link
          :to="{ name: 'Login' }"
          class="font-medium text-blue-500 ml-1 cursor-pointer no-underline"
          >here</router-link
        >
      </div>
    </div>
  </div>
</template>

<script>
import authService from "@/services/auth/auth-service";

export default {
  name: "Register",
  data() {
    return {
      registration: {
        email: "",
        password: "",
        confirmPassword: "",
      },
      error: {
        message: "",
      },
    };
  },
  methods: {
    async register() {
      if (
        this.registration.password.trim() !==
        this.registration.confirmPassword.trim()
      ) {
        this.error.message = "Password and confirm password must match";
        this.resetForm();
        return;
      } else {
        this.error.message = "";
      }

      if (this.registration.email === "" || this.registration.password === "") {
        this.error.message = "Please enter both email and password";
        this.resetForm();
        return;
      } else {
        this.error.message = "";
      }

      try {
        const user = await authService.register(
          this.registration.email,
          this.registration.password
        );
        
        if (user) {
          this.resetForm();
        }
      } catch (e) {
        this.error.message = "Email already exists";
        this.resetForm();
      }
    },
    resetForm() {
      this.registration = {
        email: "",
        password: "",
        confirmPassword: "",
      };
    },
  },
};
</script>

<style scoped>
</style>